% This m-file is used to measure Open Quotient (Oq) from DEGG signal (closing peaks) and
% EGG signal (3/7 method)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%variables to be included%%%%%%%%%%%%%%%%%
% dataDir1  ....... path where sounds to be located are located
% dataDir2 ........... path where results will be stored
% seuil = positive threshold for the detection on the degg
% this .m file uses directoire.txt in order to get names of files to be analysed
% 
% written 10/2002 by cedric.gendrot@univ-paris3.fr


clear all
close all
    
    
%----------------------------------------------------------   
dataDir1='sons\';
dataDir2='resultats\';
seuil = 0.05;
%---------------------------------------------------------- 





% this opens a .txt file containing all the wav files to be analysed ... the analysis stops at the first blank
fid=fopen('directoire.txt');
if fid==-1
    disp('pas trouv le fichier');
    return
 end
 
   fname= fgetl(fid)
 while fname ~= -1
     
     
     
     
     
     
     
    
    %----------------------------------------------------------------------------------
    % debut des calculs
    %----------------------------------------------------------------------------------
    
     
     
     
sound = wavread([dataDir1,fname]);

oFid1=fopen([dataDir2,fname,'_oq2.txt'],'wt');




%---------------------------------------------------------------------------------
    % file minus 1 sample

n=2:1:length(sound);

sound2(n)=(sound(n));


 
 
%----------------------------------------------------------------------------------
% calcul de la derivee

n=2:1:length(sound);
   Pt(n)=[sound(n)-sound(n-1)];




%---------------------------------------------------------------------------------- 
 % dtection de pics sur la drive(maxima)    Mx
 
peakCount=0;
 
 for n=50:length(Pt)-30
    
    if Pt(n)>seuil & Pt(n)>=Pt(n-49) & Pt(n)>=Pt(n-48) & Pt(n)>=Pt(n-47) & Pt(n)>=Pt(n-46) & Pt(n)>=Pt(n-45)& Pt(n)>=Pt(n-44) & Pt(n)>=Pt(n-43) & Pt(n)>=Pt(n-42) & Pt(n)>=Pt(n-41) & Pt(n)>=Pt(n-40) & Pt(n)>=Pt(n-39) & Pt(n)>=Pt(n-38) & Pt(n)>=Pt(n-37) & Pt(n)>=Pt(n-36) & Pt(n)>=Pt(n-35)& Pt(n)>=Pt(n-34) & Pt(n)>=Pt(n-33) & Pt(n)>=Pt(n-32) & Pt(n)>=Pt(n-31) & Pt(n)>=Pt(n-30) & Pt(n)>=Pt(n-29) & Pt(n)>=Pt(n-28) & Pt(n)>=Pt(n-27) & Pt(n)>=Pt(n-26) & Pt(n)>=Pt(n-25)& Pt(n)>=Pt(n-24) & Pt(n)>=Pt(n-23) & Pt(n)>=Pt(n-22) & Pt(n)>=Pt(n-21) & Pt(n)>=Pt(n-20) & Pt(n)>=Pt(n-19) & Pt(n)>=Pt(n-18) & Pt(n)>=Pt(n-17) & Pt(n)>=Pt(n-16) & Pt(n)>=Pt(n-15)& Pt(n)>=Pt(n-14) & Pt(n)>=Pt(n-13) & Pt(n)>=Pt(n-12) & Pt(n)>=Pt(n-11) & Pt(n)>=Pt(n-10) & Pt(n)>=Pt(n-9) & Pt(n)>=Pt(n-8) & Pt(n)>=Pt(n-7) & Pt(n)>=Pt(n-6) & Pt(n)>=Pt(n-5)& Pt(n)>=Pt(n-4) & Pt(n)>=Pt(n-3) & Pt(n)>=Pt(n-2) & Pt(n)>=Pt(n-1) & Pt(n)>Pt(n+1)& Pt(n)>Pt(n+2) & Pt(n)>Pt(n+3)& Pt(n)>Pt(n+4) & Pt(n)>Pt(n+5)& Pt(n)>Pt(n+6) & Pt(n)>Pt(n+7)& Pt(n)>Pt(n+8) & Pt(n)>Pt(n+9) & Pt(n)>Pt(n+10) & Pt(n)>Pt(n+11) & Pt(n)>Pt(n+12) & Pt(n)>Pt(n+13) & Pt(n)>Pt(n+14)& Pt(n)>Pt(n+15)& Pt(n)>Pt(n+16)& Pt(n)>Pt(n+17)& Pt(n)>Pt(n+18)& Pt(n)>Pt(n+19)& Pt(n)>Pt(n+20)& Pt(n)>Pt(n+21)& Pt(n)>Pt(n+22)& Pt(n)>Pt(n+23)& Pt(n)>Pt(n+24)& Pt(n)>Pt(n+25)& Pt(n)>Pt(n+26)& Pt(n)>Pt(n+27)& Pt(n)>Pt(n+28)& Pt(n)>Pt(n+29)& Pt(n)>Pt(n+30)
              
 peakCount=peakCount+1;
 
             %  uncomment the following lines if you wish to plot degg and positive peak detection
            
             figure(1),   hold on; 
             subplot(2,1,1); plot(Pt), 
             plot(n,Pt(n),'+r');
    
 Mx(peakCount)=n;
      end
   end
   

  
 %----------------------------------------------------------------------------------
 % dtection des minima sur la drive    Mi
 
minCount=0;

for n=1:length(Mx)-1

    minCount=minCount+1;
    

    [yMin,Mi(minCount)]=min(Pt(Mx(n):Mx(n+1)));
    
 Mi(minCount)=Mi(minCount)+Mx(n)-1;
    

%  uncomment the following line if you wish to plot degg and positive peak detection
        
        % plot((Mi),Pt(Mi),'+r');
        
 
end





%---------------------------------------------------------------------------------- 
 % dtection de pics sur le signal EGG (maxima)   Mx2
 


 
 peakCount2=0;
 
 for n=1:length(Mx)-1
    
    
 peakCount2=peakCount2+1;
 
 [yMax2,Mx2(peakCount2)]=max(sound((Mx(n)):(Mi(n))));
    
 Mx2(peakCount2)=Mx2(peakCount2)+Mx(n);

    
  %  fprintf(oFid1,'%d\t%8.6f\n',n,Pt(n));
    
          
    end
%plot((Mx2),sound(Mx2),'+g');
 

 %----------------------------------------------------------------------------------
 % dtection des minima sur le signal EGG  Mi2
 
 
  
 minCount2=0;
 
 for n=1:length(Mi)-1
 minCount2=minCount2+1;
 [ymin2,Mi2(minCount2)]=min(sound((Mx2(n)):(Mx2(n+1))));

 Mi2(minCount2)=Mi2(minCount2)+Mx2(n)-1;
 
 %   fprintf(oFid

    end
% plot((Mi2),sound(Mi2),'+g');
 




%----------------------------------------------------------------------------------
% dtection des 10%  partir de Mx2 et Mi2 phase d'ouverture....a....et....c.....
% en effet on commence tjs par un pic maximum...


seuil1=0;
seuil2=0;
seuil5=0;

%----------------------------------------------------------------------------------
% dtection des minima par seuil 3:7 
seuil3_7=0;

 for n=1:length(Mi)-1
    

for z=(Mx2(n)):(Mi2(n))
   
    ecart1b(n)= sound(Mx2(n))- sound(Mi2(n));
    ecart1b(n)=(ecart1b(n))/10;
    ecart1(n)= sound(Mx2(n))-ecart1b(n);
    
    ecart2b(n)=(ecart1b(n))*9;
    ecart2(n)= sound(Mx2(n))-ecart2b(n);
    
%-----------------------------------------------------------------------------------
%ici on rajoute un ecart au milieu pour faire un dbut et une fin....d'ouverture
		ecart5b(n)=(ecart1b(n))*5;
    ecart5(n)= sound(Mx2(n))-ecart5b(n);

%-----------------------------------------------------------------------------------
	ecart3_7b(n)=(ecart1b(n))*40/7;
	ecart3_7(n)= sound(Mx2(n))-ecart3_7b(n);

%-----------------------------------------------------------------------------------


    
if sound(z)>ecart1(n) & sound(z+1)<=ecart1(n)
   
   seuil1=seuil1+1;
%           plot(z,sound(z),'or');
       a(seuil1)=z;
       break
    end
 end

%-----------------------------------------------------------------------------------


for m=(Mx2(n)):(Mi2(n)-1)
    
    if sound(m)>=ecart2(n) & sound(m+1)<ecart2(n)
       
       	seuil2=seuil2+1;
%			plot(m,sound(m),'ob');
         c(seuil2)=m;
         break
	end    
end

%-----------------------------------------------------------------------------------

for m=(Mx2(n)):(Mi2(n)-1)
    
    if sound(m)>=ecart5(n) & sound(m+1)<ecart5(n)
       
       	seuil5=seuil5+1;
         b(seuil5)=m;
         break
	end    
end
%-----------------------------------------------------------------------------------

for m=(Mx2(n)):(Mi2(n)-1)
    
    if sound(m)>=ecart3_7(n) & sound(m+2)<ecart3_7(n)
       
       	seuil3_7=seuil3_7+1;
         w(seuil3_7)=m;
%          plot(m,sound(m),'ob');
         break
     end    
     
         %seuil3_7=seuil3_7+1;
         %w(seuil3_7)=w((seuil3_7)-2);
         
         %break
   
end





end

 
%----------------------------------------------------------------------------------
%----------------------------------------------------------------------------------
% dtection des 10%  partir de Mi2 et Mx2 phase de fermeture....d....et....f.....
% en effet on commence tjs par un pic maximum...et voil la 2me partie des mesures

seuil3=0;
seuil4=0;
seuil6=0;
for n=1:length(Mi)-1
   
   for m=(Mi2(n)):(Mx2(n+1)-1)
      
    ecart3b(n)= sound(Mx2(n+1))- sound(Mi2(n));
    ecart3b(n)=(ecart3b(n))/10;
    ecart3(n)= sound(Mi2(n))+ ecart3b(n);
    
    ecart4b(n)=(ecart3b(n))*9;
    ecart4(n)= sound(Mi2(n))+ecart4b(n);
    
    
%-----------------------------------------------------------------------------------
%ici on rajoute un ecart au milieu pour faire un dbut et une fin....de fermeture
		ecart6b(n)=(ecart3b(n))*5;
    ecart6(n)= sound(Mx2(n))-ecart6b(n);

%-----------------------------------------------------------------------------------
    
    
if sound(m)<=ecart3(n) & sound(m+1)>ecart3(n)
   
   seuil3=seuil3+1;
%       plot(m,sound(m),'or');
       d(seuil3)=m;
       break
    end
    end
    
    for m=(Mi2(n)):(Mx2(n+1)-1)
  
    if sound(m)<=ecart4(n) & sound(m+1)>ecart4(n)
       
       	seuil4=seuil4+1;
%			plot(m,sound(m),'ob');
         f(seuil4)=m;
         break
	end
end


for m=(Mi2(n)):(Mx2(n+1)-1)
  
    if sound(m)<=ecart6(n) & sound(m+1)>ecart6(n)
       
       	seuil6=seuil6+1;
%			plot(m,sound(m),'ob');
         e(seuil6)=m;
         break
	end
end



end

%------------------------------------------------------------------------------------
% Calcul de Oq II



for n=1:length(Mx)-3
   Oq(n)=(Mx(n+1)-w(n))/(Mx(n+1)-Mx(n));
end

for n=2:length(Mx)-3
	if Mx(n+1)-Mx(n)>500
     Oq(n)=(Mx(n)-w(n-1))/(Mx(n)-Mx(n-1));
  end
  end


for n=2:length(Mx)-4
   
   if (Oq(n)-Oq(n-1))>0.05 & (Oq(n+1)-Oq(n))<0.05
      Oq(n)=(Oq(n-1)+Oq(n+1))/2;
    elseif (Oq(n)-Oq(n-1))<0.05 & (Oq(n+1)-Oq(n))>0.05
       Oq(n)=(Oq(n-1)+Oq(n+1))/2;
      

	end
end


%--------------------------------------------------------------------------------------
% Amlioration de la prsentation de Oq II -

wav=zeros(1,length(Pt));

 for n=1:length(Mx)-3
    wav(1,Mx(n))=Oq(n);
     end


i=find(wav>0);

for n=1:length(i)-1
   if i(n+1)-i(n)<500
      wav(:,i(n)+1:i(n+1)-1)=wav(i(n));
      %elseif i(n+1)-i(n)>500
%wav(i(n))=0;
end
end


 fprintf(oFid1,'%8.7f\n',wav);


  %  uncomment the following lines if you wish to plot degg and positive peak detection
    figure(1),
    subplot(2,1,2); plot(wav)
    hold off;
   



%---------------------------------------------------------------------------------------


% il faut quand meme fermer les fichiers de sortie......(oFid)
fclose(oFid1);

disp( 'c est fini ___________');



%--------------------------------------------------------------------------------------

%----------------------------------------------------------------------------------
% fin des calculs
%----------------------------------------------------------------------------------



%----------------------------------------------------------   


clear Pt sound Mi Mi2 Mx Mx2 Oq Sq;
clear a b c d e f i j sound2 wav wav2 wav3 wav4 wav5 wav6 wav7 wav8;
clear ecart1 ecart1b ecart2 ecart2b ecart3 ecart3b ecart4 ecart4b; 
clear ecart5 ecart5b ecart6 ecart6b; 
clear ouv ouv2 ouv3 ferm ferm2 ferm3


   fname= fgetl(fid) 
end
 
fclose(fid)